Subject: Re: [PATCH] iproute2: show network device dependency tree

From: Jiri Pirko <[email-masked]>
Date: Tue, 28 Feb 2017 22:47:34 +0100

Tue, Feb 28, 2017 at 09:19:23PM CET, [email-masked] wrote:
>On Mon, 2017-02-27 at 10:55 -0800, Stephen Hemminger wrote:
>> 
>> Another alternative format would be to make -tree a output modifier and ident (like ps tree options).
>> 
>> $ ip -t link
>> 1: lo: <LOOPBACK,UP,LOWER_UP> mtu 65536 qdisc noqueue state UNKNOWN mode DEFAULT group default qlen 1
>>     link/loopback 00:00:00:00:00:00 brd 00:00:00:00:00:00
>> 8: bond0 <BROADCAST,MULTICAST> mtu 1500 qdisc pfifo_fast state DOWN mode DEFAULT group default qlen 1000
>>     link/ether 52:54:00:66:24:cd brd ff:ff:ff:ff:ff:ff 
>>     2: eth1: <BROADCAST,MULTICAST> mtu 1500 qdisc pfifo_fast master bond0 state DOWN mode DEFAULT group default qlen 1000
>>         link/ether 52:54:00:66:24:cd brd ff:ff:ff:ff:ff:ff
>
>OK, it looks better because the information is complete.
>
>I looked at several tree printing utilities and I like
>the lsblk format. But tabular format does not fit the ip-show
>well. I will try to indent the current ip-show output may be
>with fancy lines.

I don't really think that the output you provide has any value. As JiriB
wrote, it is really problematic to draw relationships between devices.
Let's take OVS as a very non-trivial example. Your patch aims to handle
only the very basic ones.